PWAVFile Class Reference

A class representing a WAV audio file. More...

`#include <pwavfile.h>`

Inheritance diagram for PWAVFile:

## Public Member Functions

PBoolean | RawRead (void *buf, PINDEX len)
PBoolean | RawWrite (const void *buf, PINDEX len)
PBoolean | FileRead (void *buf, PINDEX len)
PBoolean | FileWrite (const void *buf, PINDEX len)
off_t | RawGetPosition () const
PBoolean | RawSetPosition (off_t pos, FilePositionOrigin origin)
off_t | RawGetDataLength ()
void | SetLastReadCount (PINDEX v)
void | SetLastWriteCount (PINDEX v)
Overrides from class PFile
virtual PBoolean | Read (void *buf, PINDEX len)
| Call PFile::Read() to read in audio data and perform necessary processing such as byte-order swaping. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Call PFile::Write() to write out audio data and perform necessary processing such as byte-order swaping. More...
virtual PBoolean | Open (OpenMode mode=ReadWrite, int opts=ModeDefault)
| Open the current file in the specified mode and with the specified options. More...
virtual PBoolean | Open (const PFilePath &name, OpenMode mode=ReadWrite, int opts=ModeDefault)
| Open the specified WAV file name in the specified mode and with the specified options. More...
virtual PBoolean | Close ()
| Close the file channel. More...
virtual PBoolean | SetPosition (off_t pos, FilePositionOrigin origin=Start)
| Set the current active position in the file for the next read or write operation. More...
virtual off_t | GetPosition () const
| Get the current active position in the file for the next read or write operation. More...
Member variable access
virtual PBoolean | SetFormat (unsigned fmt)
| Find out the format of the WAV file. More...
virtual PBoolean | SetFormat (const PString &format)
virtual unsigned | GetFormat () const
| Find out the format of the WAV file. More...
virtual PString | GetFormatAsString () const
virtual unsigned | GetChannels () const
| Find out the number of channels the WAV file has. More...
virtual void | SetChannels (unsigned v)
virtual unsigned | GetSampleRate () const
| Find out the sample rate of the WAV file in Hz. More...
virtual void | SetSampleRate (unsigned v)
virtual unsigned | GetSampleSize () const
| Find out how may bits there are per sample, eg 8 or 16. More...
virtual void | SetSampleSize (unsigned v)
virtual unsigned | GetBytesPerSecond () const
| Find out how may bytes there are per second. More...
virtual void | SetBytesPerSecond (unsigned v)
off_t | GetHeaderLength () const
| Find out the size of WAV header presented in the file. More...
virtual off_t | GetDataLength ()
| Find out how many bytes of audio data there are. More...
PBoolean | IsValid () const
| Determine if the WAV file is a valid wave file. More...
PString | GetFormatString () const
| Return a string that describes the WAV format. More...
void | SetAutoconvert ()
| Enable autoconversion between PCM-16 and the native format. More...
Public Member Functions inherited from PFile
Comparison | Compare (const PObject &obj) const
| Determine the relative rank of the two objects. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
| PFile ()
| Create a file object but do not open it. More...
| PFile (OpenMode mode, int opts=ModeDefault)
| Create a unique temporary file name, and open the file in the specified mode and using the specified options. More...
| PFile (const PFilePath &name, OpenMode mode=ReadWrite, int opts=ModeDefault)
| Create a file object with the specified name and open it in the specified mode and with the specified options. More...
| ~PFile ()
| Close the file on destruction. More...
PBoolean | Exists () const
| Check for file existance. More...
PBoolean | Access (OpenMode mode)
| Check for file access modes. More...
PBoolean | Remove (PBoolean force=false)
| Delete the current file. More...
PBoolean | Rename (const PString &newname, PBoolean force=false)
| Change the current files name. More...
PBoolean | Copy (const PFilePath &newname, PBoolean force=false)
| Make a copy of the current file. More...
PBoolean | Move (const PFilePath &newname, PBoolean force=false)
| Move the current file. More...
const PFilePath & | GetFilePath () const
| Get the full path name of the file. More...
void | SetFilePath (const PString &path)
| Set the full path name of the file. More...
virtual off_t | GetLength () const
| Get the current size of the file. More...
virtual PBoolean | SetLength (off_t len)
| Set the size of the file, padding with 0 bytes if it would require expanding the file, or truncating it if being made shorter. More...
PBoolean | IsEndOfFile () const
| Determine if the current file position is at the end of the file. More...
PBoolean | GetInfo (PFileInfo &info)
| Get information (eg protection, timestamps) on the current file. More...
PBoolean | SetPermissions (int permissions)
| Set permissions on the current file. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static PWAVFile * | format (const PString &format)
static PWAVFile * | format (const PString &format, PFile::OpenMode mode, int opts=PFile::ModeDefault)
Static Public Member Functions inherited from PFile
static PBoolean | Exists (const PFilePath &name)
| Check for file existance. More...
static PBoolean | Access (const PFilePath &name, OpenMode mode)
| Check for file access modes. More...
static PBoolean | Remove (const PFilePath &name, PBoolean force=false)
| Delete the specified file. More...
static PBoolean | Remove (const PString &name, PBoolean force=false)
static PBoolean | Rename (const PFilePath &oldname, const PString &newname, PBoolean force=false)
| Change the specified files name. More...
static PBoolean | Copy (const PFilePath &oldname, const PFilePath &newname, PBoolean force=false)
| Make a copy of the specified file. More...
static PBoolean | Move (const PFilePath &oldname, const PFilePath &newname, PBoolean force=false)
| Move the specified file. More...
static PBoolean | GetInfo (const PFilePath &name, PFileInfo &info)
| Get information (eg protection, timestamps) on the specified file. More...
static PBoolean | SetPermissions (const PFilePath &name, int permissions)
| Set permissions on the specified file. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Protected Member Functions

void | Construct ()
bool | SelectFormat (unsigned fmt)
bool | SelectFormat (const PString &format)
PBoolean | ProcessHeader ()
PBoolean | GenerateHeader ()
PBoolean | UpdateHeader ()
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PBYTEArray | wavHeaderData
PWAV::FMTChunk | wavFmtChunk
PBYTEArray | extendedHeader
bool | isValidWAV
unsigned int | origFmt
PWAVFileFormat * | formatHandler
PBoolean | autoConvert
PWAVFileConverter * | autoConverter
off_t | lenHeader
off_t | lenData
bool | header_needs_updating
Protected Attributes inherited from PFile
PFilePath | path
| The fully qualified path name for the file. More...
PBoolean | removeOnClose
| File is to be removed when closed. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Construction

enum | WaveType { fmt_PCM = 1, fmt_MSADPCM = 2, fmt_ALaw = 6, fmt_uLaw = 7, fmt_VOXADPCM = 0x10, fmt_IMAADPCM = 0x11, fmt_GSM = 0x31, fmt_G728 = 0x41, fmt_G723 = 0x42, fmt_MSG7231 = 0x42, fmt_G726 = 0x64, fmt_G722 = 0x65, fmt_G729 = 0x83, fmt_VivoG7231 = 0x111, PCM_WavFile = fmt_PCM, G7231_WavFile = fmt_VivoG7231, fmt_NotKnown = 0x10000 }
| When a file is opened for writing, we can specify if this is a PCM wav file or a G.723.1 wav file. More...
| PWAVFile (unsigned format=fmt_PCM)
| Create a WAV file object but do not open it. More...
| PWAVFile (OpenMode mode, int opts=ModeDefault, unsigned format=fmt_PCM)
| Create a unique temporary file name, and open the file in the specified mode and using the specified options. More...
| PWAVFile (const PFilePath &name, OpenMode mode=ReadWrite, int opts=ModeDefault, unsigned format=fmt_PCM)
| Create a WAV file object with the specified name and open it in the specified mode and with the specified options. More...
| PWAVFile (const PString &format, const PFilePath &name, OpenMode mode=PFile::ReadWrite, int opts=PFile::ModeDefault)
| ~PWAVFile ()
| Close the file before destruction. More...

## Additional Inherited Members

Public Types inherited from PFile
enum | OpenMode { ReadOnly, WriteOnly, ReadWrite }
| When a file is opened, it may restrict the access available to operations on the object instance. More...
enum | OpenOptions { ModeDefault = -1, MustExist = 0, Create = 1, Truncate = 2, Exclusive = 4, Temporary = 8, DenySharedRead = 16, DenySharedWrite = 32 }
| When a file is opened, a number of options may be associated with the open file. More...
enum | FilePositionOrigin { Start = SEEK_SET, Current = SEEK_CUR, End = SEEK_END }
| Options for the origin in setting the file position. More...
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Detailed Description

A class representing a WAV audio file.

## Member Enumeration Documentation

enum PWAVFile::WaveType

When a file is opened for writing, we can specify if this is a PCM wav file or a G.723.1 wav file.

Enumerator
fmt_PCM | PCM, 8kHz, 16 bit, mono.
fmt_MSADPCM | MS-ADPCM, 8kHz, mono.
fmt_ALaw | A-Law 8kHz.
fmt_uLaw | u-Law 8kHz
fmt_VOXADPCM | OKI ADPCM.
fmt_IMAADPCM | IMA-ADPCM, 8kHz mono.
fmt_GSM | GSM.
fmt_G728 | RFC2361.
fmt_G723 | RFC2361.
fmt_MSG7231 | Microsoft G.723.1.
fmt_G726 | RFC2361.
fmt_G722 | RFC2361.
fmt_G729 | RFC2361.
fmt_VivoG7231 | VivoActive G.723.1.
PCM_WavFile |
G7231_WavFile |
fmt_NotKnown |

## Constructor & Destructor Documentation

PWAVFile::PWAVFile | ( | unsigned | format = `fmt_PCM` | ) |

Create a WAV file object but do not open it.

It does not initially have a valid file name. However, an attempt to open the file using the `PFile::Open()` function will generate a unique temporary file.

If a WAV file is being created, the type parameter can be used to create a PCM Wave file or a G.723.1 Wave file by using `WaveType` enum.

Parameters

  format | Type of WAV File to create

PWAVFile::PWAVFile | ( | OpenMode | mode,
|  | int | opts = `ModeDefault`,
|  | unsigned | format = `fmt_PCM`
| ) |  |

Create a unique temporary file name, and open the file in the specified mode and using the specified options.

Note that opening a new, unique, temporary file name in ReadOnly mode will always fail. This would only be usefull in a mode and options that will create the file.

If a WAV file is being created, the type parameter can be used to create a PCM Wave file or a G.723.1 Wave file by using `WaveType` enum.

The `PChannel::IsOpen()` function may be used after object construction to determine if the file was successfully opened.

Parameters

  mode | Mode in which to open the file.
  opts | `OpenOptions` enum for open operation.
  format | Type of WAV File to create

PWAVFile::PWAVFile | ( | const PFilePath & | name,
|  | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`,
|  | unsigned | format = `fmt_PCM`
| ) |  |

Create a WAV file object with the specified name and open it in the specified mode and with the specified options.

If a WAV file is being created, the type parameter can be used to create a PCM Wave file or a G.723.1 Wave file by using `WaveType` enum.

The `PChannel::IsOpen()` function may be used after object construction to determine if the file was successfully opened.

Parameters

  name | Name of file to open.
  mode | Mode in which to open the file.
  opts | `OpenOptions` enum for open operation.
  format | Type of WAV File to create

PWAVFile::PWAVFile | ( | const PString & | format,
|  | const PFilePath & | name,
|  | OpenMode | mode = `PFile::ReadWrite`,
|  | int | opts = `PFile::ModeDefault`
| ) |  |

Parameters

  format | Type of WAV File to create
  name | Name of file to open.
  mode | Mode in which to open the file.
  opts | `OpenOptions` enum for open operation.

PWAVFile::~PWAVFile | ( |  | ) |

Close the file before destruction.

## Member Function Documentation

virtual PBoolean PWAVFile::Close | ( |  | ) |

virtual

Close the file channel.

If a WAV file has been written to, this will update the header to contain the correct size information.

Returns
  true if close was OK.

Reimplemented from PFile.

void PWAVFile::Construct | ( |  | ) |

protected

PBoolean PWAVFile::FileRead | ( | void * | buf,
|  | PINDEX | len
| ) |  |

PBoolean PWAVFile::FileWrite | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

static PWAVFile* PWAVFile::format | ( | const PString & | format | ) |

static

static PWAVFile* PWAVFile::format | ( | const PString & | format,
|  | PFile::OpenMode | mode,
|  | int | opts = `PFile::ModeDefault`
| ) |  |

static

PBoolean PWAVFile::GenerateHeader | ( |  | ) |

protected

virtual unsigned PWAVFile::GetBytesPerSecond | ( |  | ) | const

virtual

Find out how may bytes there are per second.

virtual unsigned PWAVFile::GetChannels | ( |  | ) | const

virtual

Find out the number of channels the WAV file has.

Typically this is 1 for mono and 2 for stereo.

virtual off_t PWAVFile::GetDataLength | ( |  | ) |

virtual

Find out how many bytes of audio data there are.

virtual unsigned PWAVFile::GetFormat | ( |  | ) | const

virtual

Find out the format of the WAV file.

Eg 0x01 for PCM, 0x42 or 0x111 for G.723.1.

virtual PString PWAVFile::GetFormatAsString | ( |  | ) | const

virtual

PString PWAVFile::GetFormatString | ( |  | ) | const

inline

Return a string that describes the WAV format.

References formatHandler, and PWAVFileFormat::GetFormatString().

off_t PWAVFile::GetHeaderLength | ( |  | ) | const

Find out the size of WAV header presented in the file.

virtual off_t PWAVFile::GetPosition | ( |  | ) | const

virtual

Get the current active position in the file for the next read or write operation.

The WAV header is excluded from calculation the position.

Returns
  current file position relative to the end of the WAV header.

Reimplemented from PFile.

virtual unsigned PWAVFile::GetSampleRate | ( |  | ) | const

virtual

Find out the sample rate of the WAV file in Hz.

virtual unsigned PWAVFile::GetSampleSize | ( |  | ) | const

virtual

Find out how may bits there are per sample, eg 8 or 16.

PBoolean PWAVFile::IsValid | ( |  | ) | const

inline

Determine if the WAV file is a valid wave file.

Returns
  true indicates that the WAV file is valid false indicates that the WAV file is invalid

References isValidWAV.

virtual PBoolean PWAVFile::Open | ( | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`
| ) |  |

virtual

Open the current file in the specified mode and with the specified options.

If the file object already has an open file then it is closed.

If there has not been a filename attached to the file object (via `SetFilePath()`, the `name` parameter in the constructor or a previous open) then a new unique temporary filename is generated.

Returns
  true if the file was successfully opened.

Parameters

  mode | Mode in which to open the file.
  opts | Options for open operation.

Reimplemented from PFile.

virtual PBoolean PWAVFile::Open | ( | const PFilePath & | name,
|  | OpenMode | mode = `ReadWrite`,
|  | int | opts = `ModeDefault`
| ) |  |

virtual

Open the specified WAV file name in the specified mode and with the specified options.

If the file object already has an open file then it is closed. This reads (and validates) the header for existing files. For new files, it creates a new file (and header) using the type of WAV file specified in the class constructor.

Note: if `mode` is StandardInput, StandardOutput or StandardError, then the `name` parameter is ignored.

Returns
  true if the file was successfully opened.

Parameters

  name | Name of file to open.
  mode | Mode in which to open the file.
  opts | `OpenOptions` enum for open operation.

Reimplemented from PFile.

PBoolean PWAVFile::ProcessHeader | ( |  | ) |

protected

off_t PWAVFile::RawGetDataLength | ( |  | ) |

off_t PWAVFile::RawGetPosition | ( |  | ) | const

PBoolean PWAVFile::RawRead | ( | void * | buf,
|  | PINDEX | len
| ) |  |

PBoolean PWAVFile::RawSetPosition | ( | off_t | pos,
|  | FilePositionOrigin | origin
| ) |  |

PBoolean PWAVFile::RawWrite | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual PBoolean PWAVFile::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Call PFile::Read() to read in audio data and perform necessary processing such as byte-order swaping.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the read bytes.
  len | Maximum number of bytes to read into the buffer.

Reimplemented from PFile.

bool PWAVFile::SelectFormat | ( | unsigned | fmt | ) |

protected

bool PWAVFile::SelectFormat | ( | const PString & | format | ) |

protected

void PWAVFile::SetAutoconvert | ( |  | ) |

Enable autoconversion between PCM-16 and the native format.

virtual void PWAVFile::SetBytesPerSecond | ( | unsigned | v | ) |

virtual

virtual void PWAVFile::SetChannels | ( | unsigned | v | ) |

virtual

virtual PBoolean PWAVFile::SetFormat | ( | unsigned | fmt | ) |

virtual

Find out the format of the WAV file.

Eg 0x01 for PCM, 0x42 or 0x111 for G.723.1.

virtual PBoolean PWAVFile::SetFormat | ( | const PString & | format | ) |

virtual

void PWAVFile::SetLastReadCount | ( | PINDEX | v | ) |

inline

References PChannel::lastReadCount.

void PWAVFile::SetLastWriteCount | ( | PINDEX | v | ) |

inline

References PChannel::lastWriteCount.

virtual PBoolean PWAVFile::SetPosition | ( | off_t | pos,
|  | FilePositionOrigin | origin = `Start`
| ) |  |

virtual

Set the current active position in the file for the next read or write operation.

The `pos` variable is a signed number which is added to the specified origin. For `origin` == PFile::Start only positive values for `pos` are meaningful. For `origin` == PFile::End only negative values for `pos` are meaningful.

Note that for a WAV file, the origin of the file is right after the header. That is, the WAV header is not included when perform SetPosition().

Returns
  true if the new file position was set.

Parameters

  pos | New position to set.
  origin | Origin for position change.

Reimplemented from PFile.

virtual void PWAVFile::SetSampleRate | ( | unsigned | v | ) |

virtual

virtual void PWAVFile::SetSampleSize | ( | unsigned | v | ) |

virtual

PBoolean PWAVFile::UpdateHeader | ( |  | ) |

protected

virtual PBoolean PWAVFile::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Call PFile::Write() to write out audio data and perform necessary processing such as byte-order swaping.

Returns
  true indicates that at least one character was written to the channel. false means no bytes were written due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the write bytes.
  len | Maximum number of bytes to write to the channel.

Reimplemented from PFile.

## Member Data Documentation

PBoolean PWAVFile::autoConvert

protected

PWAVFileConverter* PWAVFile::autoConverter

protected

PBYTEArray PWAVFile::extendedHeader

protected

PWAVFileFormat* PWAVFile::formatHandler

protected

Referenced by GetFormatString().

bool PWAVFile::header_needs_updating

protected

bool PWAVFile::isValidWAV

protected

Referenced by IsValid().

off_t PWAVFile::lenData

protected

off_t PWAVFile::lenHeader

protected

unsigned int PWAVFile::origFmt

protected

PWAV::FMTChunk PWAVFile::wavFmtChunk

protected

PBYTEArray PWAVFile::wavHeaderData

protected

The documentation for this class was generated from the following file:

- pwavfile.h